//========================================================================================
// main.java
// ---------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
// $Id: //CBT-depot/CompBioToolsApps/readpainter/ReadPaint.java#9 $
//----------------------------------------------------------------------------------------
//
//========================================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8.........9
//
//
import javax.swing.*;
import javax.swing.event.MouseInputAdapter;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

//import edu.bcm.atlas.MultiPlatformSupport.NativeLoader;
// import NativeLoader;
//import edu.bcm.atlas.*;

public class ReadPaint extends JFrame{
  ReadPaintPanel mPanel;
  static JProgressBar progressBar;
	 
  static {
    // Figure out what platform we are on, OSX, Linux, Windows...
    // extract and load the appropriate native library out of the .jar file. 
    NativeLoader nl = new NativeLoader();
    nl.LoadLibrary("JReadPainter");
  }
	 
  public ReadPaint(ReadPainter r){
    super("Atlas Read Painter");
    
    addWindowListener(new WindowAdapter() {
	public void windowClosing(WindowEvent e) {System.exit(0);}
      });
    
    mPanel = new ReadPaintPanel(r);
    
    JPanel plotPanel = new JPanel();
    plotPanel.setLayout(new BorderLayout());
    plotPanel.add(mPanel,BorderLayout.CENTER);
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(plotPanel,BorderLayout.CENTER);
	 
    buildMenu();
    pack();
  }
 
  //--------------------------------
  // * buildMenu
  //--------------------------------
  //	 
  private void buildMenu() { // Opens buildMenu method definition 
    JMenuBar mb = new JMenuBar();
    JMenu menu = new JMenu("File");
    JMenuItem item = new JMenuItem("Exit"); 
		
    item.addActionListener(new ActionListener() { 
	public void actionPerformed(ActionEvent e) {System.exit(0);}
      }); // Closes addActionListener method 
				
    menu.add(item);
    mb.add(menu);
    setJMenuBar(mb); 
  }
	
  //--------------------------------
  // * main
  //--------------------------------
  //
  public static void main(String argv[]) 
  {
    String SourceName = argv[0];
    String CMName = argv[1];

    ReadPainter r = new ReadPainter();
    System.out.print("Reading "+SourceName+"...");
    r.ReadSource(SourceName);
    System.out.println("done.");
    System.out.print("Reading "+CMName+"...");
    r.ReadCM(CMName);
    System.out.println("done.");

    System.out.print("Merging alignments...");
    r.MergeAlignments();
    System.out.println("done.");

    // save the alignment to a file...
    if (argv.length == 3){
      int start,end;
      Integer I = new Integer(0);
      if (argv.length ==5){
	start = I.parseInt(argv[3]);
	end = I.parseInt(argv[4]);
      }else{
	start = 0;
	end = r.GetSourceSize();
      }
      
      r.PrintAlignment(argv[2],start,end,100);
      System.exit(1);
    }else{
      // otherwise, launch a gui browser...
      ReadPaint TP = new ReadPaint(r);
      TP.setVisible(true);
    }
  }
}
