//========================================================================================
// AceViewPanel.java
// ---------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------
// $Id: //CBT-depot/CompBioToolsApps/readpainter/ReadPaintPanel.java#4 $
//----------------------------------------------------------------------------------------
//
//========================================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8.........9
//

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.imageio.*;

//import edu.bcm.atlas.*;

//-----------------------------------------------------------------------------
// * ReadPaintPanel
//-----------------------------------------------------------------------------
//
public class ReadPaintPanel extends JPanel 
  implements AdjustmentListener
{	
  
  DrawArea mDrawingArea;
  JLabel mLabel;
  JScrollBar  mHScroll;
		
  private Dimension size;
  
  ReadPainter mR;
  private int cNum = 0;
  private int cSize = 0;
  private int winStart = 0;
  private int winEnd = 50;
  private int winWidth = 50;

  int MaxNameSize = 10;
  String MaxName;

  int mouseX;
  int mouseY;  
  boolean bDrawLabel = true;
  String LabelStr = "";

  public void adjustmentValueChanged(AdjustmentEvent e)
  {
    winStart = mHScroll.getValue();
    winEnd = winStart+winWidth-1;
    repaint();
  }

  //  public void valueChanged(ListSelectionEvent e){

  // }

  /* Selection of new contig, which we do not have. 
     public void valueChanged(ListSelectionEvent e)
     {
     if (e.getValueIsAdjusting()) return;
	 
     JList theList = (JList)e.getSource();
     if(theList.isSelectionEmpty()) return;
     else{
     cNum = theList.getSelectedIndex();
		
     //	System.out.println("cNum="+cNum);
		
     int cSize = mA.GetContigSize(cNum);
     MaxName = GetMaxName(cNum); 

     mHScroll.setMaximum(cSize);
		
     //		size.width = cSize/mScale;
     //size.height = xaxis + 75;
     //setPreferredSize(size);
		
     repaint();
     }
     }
  */

  public class DrawArea extends JPanel implements MouseMotionListener{
	 
    public void mouseMoved(MouseEvent e){
      mouseX = e.getX();
      mouseY = e.getY();
		
      bDrawLabel = false;
		
      // Don't want to repaint if we are too close to left or bottom. 
      if ((mouseX > 5+MaxNameSize) && (mouseY < getSize().height-10)){
	bDrawLabel = true;
      }		
      repaint();	 
    }
	 
    public void mouseDragged(MouseEvent e){
    }

    protected void paintComponent(Graphics g){

      int markerOffset = 20;
      int consensusOffset = 50;
      int alignOffset = 70;
      
      
      super.paintComponent(g);	
      Graphics2D g2d = (Graphics2D) g;

      Font f = new Font("Geneva",Font.BOLD,12);
      g2d.setFont(f);
			 
      FontMetrics fontMetrics = g2d.getFontMetrics();		
      MaxNameSize = fontMetrics.stringWidth(MaxName)+10;

      cSize = mR.GetSourceSize();
      g2d.setColor(Color.black);		

      int x = 10;
      int y = 20;

      Character c = new Character('z');
      y = alignOffset;
      int winReads = mR.GetNumReadsInWindow(winStart,winEnd);

      g2d.setColor(Color.black);
      for(int r = 0;r < winReads;r++){
	String rName = mR.GetWindowReadName(winStart,winEnd,r);
	g2d.drawString(rName,x,y);
	y=y+15;
      }
      g2d.setColor(Color.black);
		
      x = 10+MaxNameSize;
      g2d.setColor(Color.magenta);
      for(int cIdx = winStart;cIdx <winEnd;cIdx++){

	if ((cIdx % 10) == 0){
	  g2d.setColor(Color.blue);
	  String marker = " "+cIdx;
	  g2d.drawString(marker,x-5,markerOffset);
	  g2d.drawLine(x,markerOffset,x,markerOffset+10);
	}		 

	g2d.setColor(Color.magenta);
	char cbase = (char) mR.GetSourceBase(cIdx);
	String cbaseStr = ""+cbase;
	g2d.drawString(cbaseStr,x,consensusOffset);
		  		  
	y = alignOffset;

	String verticalStrip = mR.GetAlignedCharacters(winStart,winEnd,cIdx);

	for(int i = 0;i < verticalStrip.length();i++){
	  String bchar = verticalStrip.substring(i,i+1);
	  char bc = c.toUpperCase(bchar.charAt(0));
	  cbase = c.toUpperCase(cbase);
	
	  if (bc==cbase){
	    g2d.setColor(Color.black);
	  }else{
	    g2d.setColor(Color.red);
	  }
	  g2d.drawString(bchar,x,y);

	  Polygon rectangle = new Polygon();
	  rectangle.addPoint(x-5,y-5);
	  rectangle.addPoint(x-5,y+5);
	  rectangle.addPoint(x+5,y+5);
	  rectangle.addPoint(x+5,y-5);
			 
	  // See if the mouse is over this base
	  if (rectangle.contains(mouseX,mouseY)){
	    LabelStr = "Contig Position: "+cIdx;
	    mLabel.setText(LabelStr);
	  }

	  y=y+15;		  
	}
	x=x+15;
      }
    }
  } // End AceDrawArea extends JPanel


  String GetMaxName(){
    int NumReads = mR.GetNumReads();
    int maxSize = 0;
    String maxStr = "";
    for(int i = 0;i < NumReads;i++){
      String temp = mR.GetReadName(i);
      if (temp.length() > maxSize){
	maxSize = temp.length();
	maxStr = temp;
      }
    }
    return(maxStr);
  }

  public ReadPaintPanel(ReadPainter R){		
	  
    mR = R;				
    cSize = mR.GetSourceSize();
	 
    MaxName = GetMaxName(); 	 
    setOpaque(true);
    size = new Dimension(0,0);
	 
    size.height = 400;
    size.width =  400;
	 
    //mDrawingArea = new JPanel(){
    mDrawingArea = new DrawArea();
    setLayout(new BorderLayout());
    add(mDrawingArea,BorderLayout.CENTER);

    // I'm guessing this is the right way/place for this??
    addMouseMotionListener(mDrawingArea);
	 
    /*
    //	mDrawingArea.setBackground(Color.white);
    JScrollPane scroller = new JScrollPane(mDrawingArea);
    scroller.setPreferredSize(new Dimension(200,300));
	 
    add(scroller,BorderLayout.CENTER);	 
    */

    mLabel = new JLabel();
    mLabel.setForeground(Color.blue);
    add(mLabel,BorderLayout.NORTH);
    //	 mLabel.setText("ContigPosition:");

    mHScroll = new JScrollBar(SwingConstants.HORIZONTAL,0,winWidth,0,cSize);
    mHScroll.setUnitIncrement(1);
    mHScroll.addAdjustmentListener(this);

    add(mHScroll,BorderLayout.SOUTH);
    mDrawingArea.setPreferredSize(size);
	 
    // Let the scroll pane know to update itself and its 
    // scrollbars. 
    mDrawingArea.revalidate();
    mDrawingArea.setVisible(true);
  }
}



