



all:
	swig -java -c++ ReadPainter.i
	/home/hgsc/bin/gcc -DGCC3 -c ReadPainter.cc ReadPainter_wrap.cxx -I$(CBT_ROOT)/include -I$(CBT_ROOT) -I/home/hgsc/JDK/include 
	/home/hgsc/bin/gcc -dynamiclib -L$(CBT_ROOT)/lib/ ReadPainter.o ReadPainter_wrap.o $(CBT_ROOT)/lib/libgzstream.a $(CBT_ROOT)/lib/libcbt.a -lz -lstdc++ -o libJReadPainter.jnilib
	javac *.java

linux:
	swig -java -c++ ReadPainter.i
	/home/hgsc/bin/gcc -DGCC2 -c ReadPainter.cc ReadPainter_wrap.cxx -I$(CBT_ROOT)/include -I/home/hgsc/JDK/include -I/home/hgsc/JDK/include/linux/
	/home/hgsc/bin/gcc -shared -L$(CBT_ROOT)/lib/ ReadPainter.o ReadPainter_wrap.o $(CBT_ROOT)/lib/libcbt.a $(CBT_ROOT)/lib/libgzstream.a -lz -lstdc++ -o libJReadPainter.linux.so
	/home/hgsc/JDK/bin/javac *.java


solaris:
	swig -java -c++ ReadPainter.i
	/home/hgsc/bin/gcc -DGCC2 -c ReadPainter.cc ReadPainter_wrap.cxx -I$(CBT_ROOT)/include -I/home/hgsc/JDK/include -I/home/hgsc/JDK/include/solaris/
	/home/hgsc/bin/gcc -shared -L$(CBT_ROOT)/lib/ ReadPainter.o ReadPainter_wrap.o $(CBT_ROOT)/lib/libcbt.a $(CBT_ROOT)/lib/libgzstream.a -lz -lstdc++ -o libJReadPainter.solaris.so
	/home/hgsc/JDK/bin/javac *.java


java:
	/home/hgsc/JDK/bin/javac *.java	

jar:  
	jar cvf ReadPainter.jar *.class ~/java/classes/edu/bcm/atlas/MultiPlatformSupport/NativeLoader.class *.jnilib

install: 
	cp -f ReadPainter.jar /home/hgsc/share/lib/java/ReadPainter/


universaljar: 
	/home/hgsc/JDK/bin/jar -cvf ReadPainter.jar *.jnilib *.so *.class 


package:
	mkdir -p readpainter
	mkdir -p readpainter/src
	cp -f *.java *.cxx *.cc *.i mini.mk readpainter/src/
	cp -f README ReadPainter.jar  atlas-readpainter testsource.fa testcm.out readpainter-txt* readpainter/
	tar -czvf readpainter.tgz readpainter

clean:
	rm -f *.o
	rm -f *.class
	rm -f *.jnilib