#include "CBT.hh"

#include "ReadPainter.hh"

int main(int argc, char** argv)
{
  CMParse CM;
  FAFile FA;
  Sequence Source;

  ReadPainter RP;

  // Read the source sequence and the cm output. 
  cout<<"Read contig.."<<flush;
  RP.ReadSource(argv[1]);
  cout<<"done."<<endl;

  cout<<"Parse CM.."<<flush;
  RP.ReadCM(argv[2]);
  cout<<"done."<<endl;

  cout<<"Merging alignments..."<<flush;
  RP.MergeAlignments();
  cout<<"done."<<endl;

  int start,end;
  if (argc == 6){
    start = atoi(argv[4]);
    end = atoi(argv[5]);
  }else{
    start = 0;
    end = RP.GetSourceSize();    
  }
  RP.PrintAlignment(argv[3],0,RP.GetSourceSize(),100);
}



/*

  // Create a source that includes the union of all of the 
  // source pads inserted by the individual read alignments. 
  cout<<"Construct union source..."<<flush;
  RP.ConstructSourceWithUnionOfReadPads();
  cout<<"done."<<endl;

  // Setup the BaseLocations structure. 
  cout<<"Init with queries..."<<flush;
  RP.InitWithQueries();
  cout<<"done."<<endl;

  cout<<"Reads:"<<endl;
  for(int i = 0;i < RP.mAlignedReads.size();i++){
    cout<<RP.mAlignedReads[i]<<endl<<endl;
  }

  cout<<"Source:"<<endl;
  for(int s = 0;s< RP.mUnionSource.size();s++){
    int SourceIdxDepad = RP.mUnionSource.Padded2Depadded(s);
    cout<<s<<"\t"<<RP.mUnionSource[s]<<"\t"<<SourceIdxDepad<<endl;
  }

  cout<<"Merge read pads..."<<flush;
  RP.MergeReadPads();
  cout<<"done."<<endl;


  cout<<"Union source size="<<RP.mUnionSource.size()<<endl;
  cout<<"Merged reads size="<<RP.mMergedReads.size()<<endl;
*/














